////===============================================================================================
#include  "M451Series.h"
#include  "IP_Initial.h"
#include  "A_Motor.h"
#include  "M451_FOC_LIB.h"

#define  RELAY_ON()                (PA2 = 1)              // Դ̵  
#define  RELAY_OFF()               (PA2 = 0) 

int32_t          RPM_Set = RPM_STOP_VALUE -1 ;            // ת趨ֵͣתֵС,״̬2ִнȥ״̬0
int32_t volatile RpmMechanical_Set = 0 ;                  // еת趨ֵ        
int16_t          Speed_Adc ;                              // ť ADC ͨ˲ݶֵ

int16_t          Vbus_Dwon_Limit = VIN_WORK_MIN_UP ;      // ͹ѹ
uint32_t         Tick_Voltage_Up, Tick_Voltage_Dwon ;     // Դѹֵ¿"𶯵ѹСֵ"ʱ

 int32_t  Test_Period(void) ;                             // ˳תʱ,תٺͷƵĺ
uint32_t  Tx0FillFiFo(char*pStr, uint32_t Cnt) ;          // ӡ,дͻTx_FiFo 󷵻, ȷ
uint32_t  BinToHex_Str(uint32_t Number, char*pStr) ;
uint32_t  BinToDec_Str(uint32_t Number, char*pStr) ;

static char String[16] = "\n=0x";                         // ڴӡַ

// M451LC3AE: LQFP48, 39GPIO,ֵDOUT,䷽MODE,书MFP, GPIOȷֵ,м쳣 
void GPIO_Init(void)                           
{                                                      // PA0~3, 4
  PA->DOUT      = 0xFFF0 ;                       // PA2 ̵0ر,PA0̵0, PA1,PA3PWM10
  PA->MODE      = (GPIO_MODE_OUTPUT << 0*2)               // PA0  LED
                | (GPIO_MODE_OUTPUT << 2*2) ;             // PA2 Ƽ̵
  SYS->GPA_MFPL = SYS_GPA_MFPL_PA3MFP_PWM1_CH2 ;                           
  SYS->GPA_MFPH = 0 ;                           
                                                       // PB0~7, 8
  PB->DOUT      = 0xFFFF ;                                
  PB->MODE      = 0 ;        
  PB->DINOFF    = 0xFFFF0000 ;                            // 
  SYS->GPB_MFPL = SYS_GPB_MFPL_PB0MFP_DAC                 // SYS_GPB_MFPL_PB0MFP_EADC_CH0             
                | SYS_GPB_MFPL_PB1MFP_EADC_CH1 
                | SYS_GPB_MFPL_PB2MFP_EADC_CH2            // 8 · ADC 
                | SYS_GPB_MFPL_PB3MFP_EADC_CH3 
                | SYS_GPB_MFPL_PB4MFP_EADC_CH4             
//                | SYS_GPB_MFPL_PB4MFP_ACMP0_N           // Ӳ˲οѹ
                | SYS_GPB_MFPL_PB5MFP_ACMP0_P2            // ӲBrake
                | SYS_GPB_MFPL_PB6MFP_EADC_CH14 
                | SYS_GPB_MFPL_PB7MFP_EADC_CH15 ;                           
  SYS->GPB_MFPH = 0 ;    
                                                       // PC0~7, 8 
  PC->DOUT      = ShutDown_AllMOS ; 
  PC->MODE      = 0x40555 ;                               // PWM0·,PC9_LED 
  SYS->GPC_MFPL = SYS_GPC_MFPL_PC0MFP_PWM0_CH0 
                | SYS_GPC_MFPL_PC1MFP_PWM0_CH1 
                | SYS_GPC_MFPL_PC2MFP_PWM0_CH2
                | SYS_GPC_MFPL_PC3MFP_PWM0_CH3 
                | SYS_GPC_MFPL_PC4MFP_PWM0_CH4
                | SYS_GPC_MFPL_PC5MFP_PWM0_CH5 
                | (9ul<<SYS_GPC_MFPL_PC6MFP_Pos)          // Tx0
                | (9ul<<SYS_GPC_MFPL_PC7MFP_Pos) ;        // Rx0
  SYS->GPC_MFPH = 0 ;
                                                       // PD0~3,PD7, 5 
  PD->DOUT      = 0xFFFF ;                                
  PD->MODE      = (GPIO_MODE_QUASI << (2*2))              // PD2, brake ʹ             
                | (GPIO_MODE_OUTPUT << (7*2)) ;           // ACMP0_O 
  PD->DINOFF    = 0x00010000 ;                            //  PD0_EADC6 
  SYS->GPD_MFPL = (1ul << SYS_GPD_MFPL_PD0MFP_Pos)        // EADC6
                | SYS_GPD_MFPL_PD7MFP_ACMP0_O    
                | SYS_GPD_MFPL_PD2MFP_PWM0_BRAKE0 ;       // PD2 Brake ,
  SYS->GPD_MFPH = 0 ;                                     
                                                       // PE0,PE8~13, 7 
  PE->DOUT      = 0xFFFF ;                                // PE10 1   
  PE->MODE      = (GPIO_MODE_OUTPUT << (10*2))
                | (GPIO_MODE_QUASI << (11*2)) 
                | (GPIO_MODE_QUASI << (12*2)) 
                | (GPIO_MODE_QUASI << (13*2)) ;                           
  SYS->GPE_MFPL = 0 ;   
  SYS->GPE_MFPH = 0 ;      
                                                       // PF0~6, 7,PF34_HXT, PF56_ICE 
  PF->DOUT      = 0xFFFF ;                                
  PF->MODE      = 0 ;                           
  SYS->GPF_MFPL = 0x01100000 ;                            // PF56 SWD ӿڹ                                                

//  PE->DBEN    = 0x3800 ;                                // PE11,12,13 ʹȥ
//  GPIO->DBCTL = 0x0009 ;                                // 512HCLKȥʱ (512/72 = 7us)
//  PE->INTTYPE = 0 ;                                     // ж
//  PE->INTSRC  = ~0 ;
//  PE->INTEN   = 0x38003800 ;                            // PE11,12,13غ½ж
//  NVIC_SetPriority(GPE_IRQn, 2);
//  NVIC_EnableIRQ(GPE_IRQn) ;		

}

//==================================================================================================
//             main()  
//==================================================================================================

int main(void)
{  
  int32_t   temp32 ;
  uint32_t  Last_SysTickRelay ;  

  Timer1_Init() ;                                         // Timer1, ˺Delayus()ʱ
  PWM0_Init() ;    
  PWM0_Set_Period(gPWM_Period) ;                          // PWM  
  Set_PWM_Frequency_LPF(PWM_Frequency, 200);              // FOCƵʺ͵ͨƵ,ȱʡ15295Hz,200
  
//  PWM0->CTL0 |= 0x80000000 ;                            // PWM (дλ),                                                        
  DAC_Init() ;    
  UART0_Init(115200) ;  
  GPIO_Init() ;                                           // MSKEN=0x3F, PWM ֵ = ShutDown_AllMOS    
                                                          // ж,ܴж,ʿGPIOжϷں
  Motor_Status = 0 ;                                      
  Tick_Voltage_Up = SysTick_Relay ;                       // ¼ϵʱ
  Rotation_Direction = Expect_Direction ;                 // ȡת򿪹ֵ Expect_Direction 

  Stop_Runing = Stop_SWITCH_OFF ;                         // дֵ SysTick жLED һֱ˸
                                                  // ʹģⲿֲҪ̫ǰ, ܿϵʱԴ  
  ACMP01->CTL[0] = 0xA000 + 0x1000                        // 16PCLK/72=0.22usʹfilter
                 | 0x0100 + 0x0085;                       // λжϱ־IF0,ѡP2,,ʹܻز  
  
  EADC->CTL = EADC_CTL_ADRST_Msk                          // ADC·λ(Զ)
            | 0x00070000                                  // ʱ 8ʱ
            | EADC_CTL_ADCIEN0_Msk                        // ʹж0
            | EADC_CTL_ADCEN_Msk ;                        // Enable EADC 

//  // ˴PWM1 PFC , PWM1 ʱ(PLL)PWM0 ʱ(PCLK0)һ, ֵͬ, PWM1 Ƶʿһ
//  PWM1_Init(gPWM_Period) ;                                
//  PWM1->PERIOD[2] = (gPWM_Period*3>>2) -5*72 ;            // ڵ3/4ٶ 5us       
//  PWM1->PERIOD[4] = (gPWM_Period*3>>2) -5*72 ;            // 72ϼʱ2.5us, ¼ 2.5us 
 
  PWM0->SSTRG = PWM_SSTRG_CNTSEN_Msk ;            // ͬ12·PWM(PWM16·),MASK,ʱ
                                                          // PWM1 ڶں, ı
//  PWM1->PERIOD[2] = gPWM_Period >>1 ;                   // PWM1ʱѡPLL PWM0 ʱӿһ     
//  PWM1->PERIOD[4] = gPWM_Period >>1 ;                   // PWM1 ڱΪPWM0 һ
//  PWM1->MSKEN = 0 ;                                     // PWM1 ʼ, PFC ʹܿʼͨ
 
////============================================================================================
                                             // ǰPWM ADC ж,ADC ж 15V ѹ 
  EADC->SCTL[3] = EADC_PWM0TG0_TRIGGER | 4 ;              // PWM ADC(òͨ,Ҫĳ)
  EADC->INTSRC[0] = 1ul << 3 ;                            // ʹģ3 ADC ж0 
  NVIC_SetPriority(ADC00_IRQn, 1) ;                       // ȼ=1, ȼ0 
  NVIC_EnableIRQ(ADC00_IRQn) ;                            // ʹADC ж  

  HCLK_Switch_to_PLL() ;                                  //  PLL ȶ, HCLK ʱл PLL, 
 
  do{  Delayus(100);                                      // ADC ж IPM_Fault ֵ                                 
  }while((int8_t)IPM_Fault != ~0);                        // 15Vѹ,LED һֱ˸
               
////============================================================================================
                        // 15V ѹ,PWM  BrakeMOS ͨ,MOS û                              
  PWM0->INTSTS1 = ~0 ;                                    // жϱ־
  PWM0->INTEN1 = 0x0707 ;                                 // 07ʹܵƽBrakeж,07ʹܱж
  SYS_LockReg(0) ;  

//==========================================================================================
//   MOS ֱͨ᲻ᱨ·, Ҳͬʱֱͨͨĺôǿɼ쵽ĸMOS ·

//  RPM_Set = RPM_Stop_Value -1 ;                         // ͣתֵС,״̬2ȥ״̬0(ʼֵ,ʡ)

//  Exec_Counter = 20;    Motor_Status = 2;                                         
//  PWM0->MSKEN  = 0x3D ;                                               // bit1=0, A  MOS ͨ 50% 
//  while(Exec_Counter + Motor_Status) ;  
//  if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n A Up-Mos fail",15) ;                     
    
//  Exec_Counter = 20;    Motor_Status = 2;  
//  PWM0->MSKEN  = 0x37 ;                                               // bit3=0, B  MOS ͨ 50% 
//  while(Exec_Counter + Motor_Status) ;                   
//  if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n B Up-Mos fail",15) ;                     
// 
//  Exec_Counter = 20;    Motor_Status = 2;  
//  PWM0->MSKEN  = 0x1F ;                                               // bit5=0, C  MOS ͨ 50% 
//  while(Exec_Counter + Motor_Status) ;                    
//  if(FlagBrake & Flagb_SHUT_MOS) Tx0FillFiFo("\n C Up-Mos fail",15) ;                     
   
  Exec_Counter = PWM_10th_sec >>1;    Motor_Status = 2;   //  MOS ͨ50%,  50ms, Ծٵݳ
  PWM0->MSKEN  = 0x15;                                    // =1λ( MOS)ر, ( MOS ͨ
                                                 
  Tx0FillFiFo("\n=V23",5) ;                               
  temp32 = SYS->RSTSTS & 0xFFFF;                          // λԴĴ16λ
  SYS->RSTSTS = 0x01BF ;                                  // , д18λԴ־, λ0
  BinToHex_Str(temp32, &String[7]) ;                      // ַ,String[4]~[7] 
  Tx0FillFiFo(String, 8) ;                                // UART ַ
 
  while(FlagBrake & Flagb_SHUT_MOS){                      // MOS л,ȫ,SysTickжLED ֿ
    Delayus(1000*1000) ;
    Tx0FillFiFo("\nUp Mos fail",12) ;                     
  } 

  while(Motor_Status) ;                                   // ״̬2ִص״̬0,Ծٵݳ(50ms) 
            
  EADC->INTSRC[0] = 0 ;                                   // ADC ж, ٴε ADC ʼ
  EADC->SCTL[0] = EADC_SOFTWARE_TRIGGER | 1 ;             //  ADC_PWM01 
  EADC->SCTL[1] = EADC_SOFTWARE_TRIGGER | 2 ;             //  ADC_PWM23
  EADC->SCTL[2] = EADC_SOFTWARE_TRIGGER | 3 ;             //  ADC_PWM45 

  Last_SysTickRelay = 0 ;                                 // ʱ
  EADC->SWTRG = 1 << 0;          Delayus(200) ;
  temp32 = EADC->DAT[0] ;                                 // ѵһݶ, ֹһ        
  for(temp32=0 ; temp32<8; ++temp32 ){                      
    EADC->SWTRG = 1 << 0;          Delayus(20) ;     
    Last_SysTickRelay += (uint16_t)EADC->DAT[0] ;         // 0ʱ ADC ֵ
  }
  Zero_Current_ADC0 = (Last_SysTickRelay +4) >>3 ;        // ADC ͨ0 ʱADC ֵ
  
  Last_SysTickRelay = 0 ;
  EADC->SWTRG = 1 << 1;          Delayus(20) ;            
  temp32 = EADC->DAT[1] ;                                          
  for(temp32=0 ; temp32<8; ++temp32 ){
    EADC->SWTRG = 1 << 1;          Delayus(20) ;
    Last_SysTickRelay += (uint16_t)EADC->DAT[1] ;
  }
  Zero_Current_ADC1 = (Last_SysTickRelay +4) >>3 ;        // ADC ͨ1 ʱ ADC ֵ
  
  Last_SysTickRelay = 0 ;
  EADC->SWTRG = 1 << 2;          Delayus(20) ;
  temp32 = EADC->DAT[2] ;                                          
  for(temp32=0 ; temp32<8; ++temp32 ){    
    EADC->SWTRG = 1 << 2;          Delayus(20) ;
    Last_SysTickRelay += (uint16_t)EADC->DAT[2] ;
  }
  Zero_Current_ADC2 = (Last_SysTickRelay +4) >>3 ;        // ADC ͨ2 ʱ ADC ֵ
  
  ADC_Init() ;                                            //  PWM  ADC,  ADC ж

  Exec_Counter = 20 ;    Motor_Status = 2;                // ״̬2  50% ռձ
  PWM0->MSKEN  = 0x2A;                                    //  MOS (=1λ)ر,  MOS ͨ
  while(Motor_Status) ;                                   // ״̬2ִص״̬0

  while(FlagBrake & Flagb_SHUT_MOS){                      // 쵽·,MOS л,SysTickжLED ֿ
    Delayus(1000*1000) ;
    Tx0FillFiFo("\nDown Mos fail",14) ;                   // һӡһ, ӡ    
  } 
 
  SYS->GPF_MFPL = 0 ;                                // SWDóGPIOԺ,,ICPʱ	

//  GPE_IRQHandler();                                     // HallAngleȡóֵ,޸пƲҪ
//==============================================================================================
// ʽ: V-Ri = LPi+e; 1ADCֵ=M,i=Mi,ʱADCֵٳH, ʽҲӷĸٳ1000000MH
// V-Ri=(1000000LPMHi+e*1000000MH)/(1000M*40*25H); ΢L',ADCֵHֵi'=MHi,ʽΪ
// (40V-40Ri)=(L'Pi' + e')/(1000M*25H); ĸøUnit_Magnify =1000M*25H, e' = *Unit_Magnify*40 
// Ϲʽ, ѹʱ0.1Vٳ4ֵ,  㷴ƳUnit_Magnify = *40, 25mVֵ

// LI32λ,15λ, 17λ =131072uH,ֵٴ,оͳ10, Unit_MagnifyҲ10 

#if 1  
  Lq_Inductor  = 690 ;                                     //  uH,  
  Ld_Inductor  = 665 ;                                     //  Lq >= Ld
  Unit_Magnify = CURRENT_Adc1000*25*8 ;                    // H=8,ADCֵ8ڼ
  
#else
  Lq_Inductor  = 690 >>3;                                  // LqIq29λ: 0x1FFF_FFFF           
  Ld_Inductor  = 665 >>3;                                  // ̫LqIq(32λ),8    
  Unit_Magnify = CURRENT_Adc1000*25 ;                      // H=8 8 
  
#endif                                            //ADC12λ,815λ, Lq32.768mHͿԳ2,4,8

  Stop_Runing = Stop_POWER_LOW;    // Ƿѹ,,ȸͣת־,0ʱ,趨תRPM_Set0,ת
  
  // ѭ,1>,ǷǷѹǷµȸֲת,дStop_Runing
  //          2>,ת趨ֵ RPM_Set>0ʱתǰ׼𶯹ͻȻ𶯵ƺ
  //          3>,ťת趨ֵ RPM_Set
  
  while(1){           
    RpmMechanical_Meas =(RPM_Measure + (POLE_PAIR>>1))/ POLE_PAIR ;  // еתٲֵ,ʾ 
  
    temp32 = Vbus_0v1*150 >>8 ;                            // Ʊ=10.577 =150/256, 172/256=2/3 
    if(temp32 > 16383) temp32 = 16383 ;                    // ѹ14λ = 16383 (1638.3V)   
    Vout_Limit_f17 = temp32 << 17 ;                        // Vdq ޷ֵ17λС, 31λ

    
    //== Power ѹ,Stop_Runing еǷѹ־ ================================ 15V ѹжADC ж 
  
    if(Vbus_0v1 >= Vbus_Dwon_Limit){ Tick_Voltage_Dwon = SysTick_Relay ;                               
      if((Tick_Voltage_Up - SysTick_Relay) >= 50){ RELAY_ON();   // 220VʱҪӳ0.5~1,̵
        if((Tick_Voltage_Up - SysTick_Relay) >= 80){             // 220V̵50~100ms, ʱת
          Vbus_Dwon_Limit = VIN_WORK_MIN ;           

          Stop_Runing &= ~Stop_POWER_LOW ;                       // ѹ־
        } 
      }
      if(Vbus_0v1 > VIN_WORK_MAX) Stop_Runing |= Stop_POWER_TOO_HIGH ;    // ѹ
      else Stop_Runing &= ~Stop_POWER_TOO_HIGH ;                          // ˴ûӻز 
    }
    else{  Tick_Voltage_Up = SysTick_Relay ;                     // ѹ
      Vbus_Dwon_Limit = VIN_WORK_MIN_UP ;            
      PWM0->MSKEN  = 0x3F;                                       // عʹ 
      Exec_Counter = 6;    
      Motor_Status = 0;    
      if((Tick_Voltage_Dwon - SysTick_Relay) >= 2) RELAY_OFF();  // ʱ1~2ms, ʹܵ=0Ͽ̵ 
      
         // Other event, ·־, 

      Stop_Runing |= Stop_POWER_LOW ;                            // λѹ־, ǰ 
    }        
  
    ////==== Ƿ·, Stop_Runing еĶ·־λ ============================================
  
    if(FlagBrake & Flagb_SHUT_MOS){                              // ·,brake PWM MOSֵ
      Stop_Runing |= Stop_SHORT ; 
      if(Motor_Status != 0){ Exec_Counter = 6 ;  Motor_Status = 0;  }   // ȥ״̬0 ͨPWM->MSKEN PWM 
    } 
    
    if(IPM_Fault == ~0) Stop_Runing &= ~Stop_15V_LOW ;           // IPM Fo 16PWM 
    
    
////====  RPM_Set ֵҪת,Ҫͣת ========================================================== 
    
// ֻExec_Counter =0 ʱ޸Motor_Status Ƿֹĳ״̬δPWMжִйֱΪ״̬
// ״̬0: 6·ʹ(Ƶ) 
// ״̬1: 0ѹʹʹܣʽ߶ʽɲ, ִнȥ״̬0
// ״̬2: 0ѹ,   RPM_Set < RPM_STOP_VALUE дPWM0->MSKEN, ждMSKEN ·ʹʹ 
//                     RPM_Set >=RPM_STOP_VALUE  MOS ʹ, ߶ʽSVPWM ڸԾٵݳ 
//        ״̬2 ִRPM_Set <RPM_STOP_VALUE ȥ״̬0,  RPM_Set >0 ȥת, ȥ״̬ MOTOR_STOP_STATUS

// ״̬3,4: ϶ת,ͬ Motor_Status |=0x10; ״̬Ϊ0x130x14               
// ״̬5: ʱ䵽,RPM_Set>0 ȥ״̬4ת,򱣳״̬5
// ״̬6: ˳תʱλ, Ȼ״̬4ת   
// ״̬0x13, 0x14: ͬ״̬, תٵ͵۲ʱ Motor_Status &= ~0x30, ʧ״̬3  4  
    
    //=========================== ͬת ======================================
    if((Motor_Status & 0x10) == 0x10){  
                   
      if((RPM_Set <=0)
         &&((RPM_Measure*65536/60/PWM_Frequency) <(PULL_Ommega_Min_f16>>16))){   
        Exec_Counter = 3*PWM_10th_sec;  Motor_Status = 1;           // תٵ˾ͣ,ֹʱ䲻ʧͣ 
      }

    }    
    //===================== δͬ(ͣתת), 趨ת RPM_Set С0, Ҫת =====================
    else if(RPM_Set <= 0){                 
      if(Motor_Status >= 3){                               // 3,4,5,6,7    
          
        if(Motor_Status == 5 ){
          Rotation_Direction = Expect_Direction;           // ״̬5ʱ,ת, RPM_Set ͣתֵ
        }
        else if(Motor_Status != 7){                        // ״̬7ɶ                        
          Exec_Counter = 5*PWM_10th_sec; 
          Motor_Status = 1;                                // ״̬3,4,6ȥ״̬1 ɲ
        }   
                                              
      }
      else{                                                // ״̬ <= 2, ͣתɲ״̬                        
        Rotation_Direction = Expect_Direction ;              
        if(Motor_Status == 0){   
          if(FlagBrake & Flagb_SHUT_MOS){                             // IPM  fail , ˶·    
            if((Brake_No_Resume ==0)||(Stop_Runing & Stop_15V_LOW)){  // "·",15VͶǶ·           
              FlagBrake = 0 ;  
              Brake_No_Resume =0 ;                           // 15VѹǶ·ʱ, 0
              temp32 = SYS_UnlockReg();
                if(SYS->SRAM_STATUS) SYS->IPRST0 = 1;        // RAM , λ
                PWM0->MSKEN   = 0x3F;                        // ǰհMotor_Statusд0ûعʹ                                                           
                PWM0->INTSTS1 = ~0 ;                         // Brake־,¸PWM,PWMʹ                       
                PWM0->INTEN1  = 0x0707 ;                     // ٴʹ Brake ж
              SYS_LockReg(temp32);    
              Stop_Runing &= ~Stop_SHORT ;   
            }               				
          }
          // ״̬0 					
        }                    
        // ͣת״̬  				
      }                                                           
    }
    //========================= δͬ,趨ת RPM_Set 0,  Ҫת ===============
    else{                                                  // ״̬2,3,4,5,6ת,ֻ״̬0Զ״̬         
      if(Motor_Status + Exec_Counter ==0){                 
        
      #if 1
        temp32 = Test_Period();                            // ˳ת,˺ Angle_q =-16384 ʱ̷ת 
        
      #else                                                     
        temp32=0;  Emf_ADC_Max=0;                          // ˮ˳ת,ִTest_Period()ת
        
      #endif                                                     
        
        Emf_ADC_Max = Emf_ADC_Max*323 >> 12;               // 11ѹ (ADC/4096*5)*11*10=550/4096=0.1V ֵ        
                                                           // ߵѹ 550*0.577 =323 ѹ     
        if(temp32 >0){                                     // ÷ Emf_ADC_Max Сж˳ת׼ȷ  
          Pull_Ommega_f16 = temp32;             
          Motor_Status = 6 ;                               // ˿ܽ״̬00ѹ,ʲֵVq_out_f17
        }
        else if(Emf_ADC_Max < VIN_WORK_MIN){               // С,ֹת
          Exec_Counter = PWM_10th_sec >>1;                 // Ծٵݳ100/2=50ms 
          Motor_Status = 2 ;                               // ADCж, ɲ״̬35ת 
        }                                                         
        else if(Emf_ADC_Max < (VIN_WORK_MIN <<1)){         // ת,ɲ   
          Exec_Counter = 10*PWM_10th_sec;  
          Motor_Status = 1;                               
        }                                                  // תܿ,ɲܴ,ֱɲ 
      }      
    }               
        
    //======================================================================================== 
    // ˮ,Ϊ(ƽ),RPM_Set ͨPI , RPM_SetĸҪ͹ʸڲ

    if((Last_SysTickRelay - SysTick_Relay) >= 10){         // SysTick ж, δִ
      Last_SysTickRelay = SysTick_Relay ; 
                                                                     
      //== ť,ת趨ֵ =======================================   
      temp32    = ((uint16_t)EADC->DAT[3]) ;                            
      Speed_Adc = (temp32 + Speed_Adc*31 +16) >>5 ;        // ͨ, ȶť ADC                                 
      temp32 = Speed_Adc ;

      RpmMechanical_Set = temp32 ;                         // еת趨ֵ,עʹ˾ʵʱֵ 
      
      temp32 = RpmMechanical_Set * POLE_PAIR ;             // ת = еת*    

      //===  ѵת趨ֵtemp32, ޶֮ ================================= 
      if(Rotation_Direction != Expect_Direction)temp32 =RPM_STOP_VALUE;  //趨תʵתͬ,ͣת
      else if( Stop_Runing ) temp32 = RPM_STOP_VALUE ;                  // "ͣת"0, ת =ͣתֵ 
      else if(temp32 > RPM_SET_MAX) temp32 = RPM_SET_MAX  ;            // 趨תٳ,   
                                                                     
      if(temp32 < RPM_SET_MIN){
        if(RPM_Set <= 0){                                           // δתʱ 
          if(temp32 <(RPM_SET_MIN*3 >>2)) temp32 =RPM_STOP_VALUE;   // ֵ 3/4 ת
          else temp32 = RPM_SET_MIN ;
        } 
        else if(temp32 <(RPM_SET_MIN >>1))temp32 =RPM_STOP_VALUE;   // תʱСֵ1/2, ͣת  
        else temp32 = RPM_SET_MIN;                                
      }    
                      
      // (ƽ),ת趨ֵRPM_SetֱӸֵ,ҪӸPI , Ӽ 
           
      RPM_Set = temp32 ;                                           // ת趨ֵ =С~, ͣתʱ=ֵ
  
      #if  0                       //  #if 1  ת,               
      {  uint32_t static TCount ;
        if(RPM_Set <= 0) TCount = 0;                                    // ʵתתһʱ, ֵ<=0
        else if((Motor_Status & 0x10)&&(RPM_Measure > RPM_Set*15 >> 4)){
          if(++TCount > 500){ TCount =0;  Expect_Direction ^= 3; }        // 趨תٺ5,ת
        }         
      }  
      
      #endif 
      
    }
    
//    if(Motor_Status == 0){                              // ڲ 
//      EADC->SWTRG |= 0x20 ;                             //  ADC 
//      while(EADC->SWTRG & 0x20);                               
//      DAC->DAT = EADC->DAT[5] ;                         // DAC ʾADC 
//    }    
  
  }   // End of while(1)        
}

//==================================================================================================
//    Cnt εѹڻThreshold,  ˳תλ
//==================================================================================================

uint32_t  Wait_Level(int16_t Level, int16_t Threshold, int16_t Cnt)
{                                                         
   int16_t        temp16 ;
  uint32_t        Tim = TIMER1->CNT, Tim2 = Tim, Flag = 0; 
  uint32_t        Time_OV = 100*1000 ;                    // 100ms ʱ
   int16_t static emf_Adc_Data = 0 ; 
  
  if(Level) Time_OV >>=1 ;                                // ȸߵƽʱ,ʱ(͵ƽʱ)
  do{   
    Delayus(2);                                           
    EADC->SWTRG |= 0x20 ;                                 // 5ģⷴ
    while(EADC->SWTRG & 0x20) ; 
    temp16 = EADC->DAT[5] ;               
    emf_Adc_Data = (emf_Adc_Data + temp16) >> 1 ;         // DAC->DAT =emf_Adc_Data;   // DAC ʾƲ
    if(Emf_ADC_Min > emf_Adc_Data) Emf_ADC_Min = emf_Adc_Data ;  
    if(Emf_ADC_Max < emf_Adc_Data) Emf_ADC_Max = emf_Adc_Data ;   

    if(Level){                                            // ȴѹ Threshold
      if(temp16 > Threshold){ if(++Flag >= Cnt) break;  }  
      else{ Flag = 0;  Tim2 = TIMER1->CNT; }              // ݱ仯֮ǰʱ
    }
    else{                                                 // ȴѹ Threshold
      if(temp16 < Threshold){ if(++Flag >= Cnt) break;  }    
      else{ Flag = 0;  Tim2 = TIMER1->CNT; }              // ۵ȼ, Tim2 ǵƽʱ
    }
  }while(((TIMER1->CNT -Tim)&0xFFFFFF) < Time_OV);              
  return (Flag <<24) +Tim2 ;                              // λ0Ǽ⵽ƽ
}

//== δת0,תظ,תתٸֵ Pull_Ommega_f16,
int32_t Test_Period(void)                                 // ת, Angle_q = -16384 ʱ̷
{                 
  int32_t temp32 = 0, Reverse = 0, temp32_1, temp32_2 ;   // ܲ෴,ȽֵеǷת      
                                                          
  Emf_ADC_Max = 0;     Emf_ADC_Min = 4095;       
  Wait_Level(1,9000,5);                                   // Ʋô, ǳ 50ms ѹ                                      
  temp32_2 = Emf_ADC_Max - Emf_ADC_Min  ;                 // СֵĲ   
  if(temp32_2 < 82*2) return 0;                           // С82*2*5/4096 =0.2 V ƽû
                                                          
  Wait_Level(0,-200,5);                                   // Ʋô, 100ms ѹ 
                                                                           // 150ms⵽͵ƽĸ             
  temp32_2 = Emf_ADC_Max - Emf_ADC_Min  ;                 // СֵĲ 
  temp32_2 = Emf_ADC_Min +(temp32_2*7 >>4);               // һԵһ,  Angle_q = -16384 ʱ              
  temp32_1 = Wait_Level(0,temp32_2-41,5);                 // 41*5/4096 =0.05V     
  if((temp32_1 >>24) ==0) return 0;                           
  
  temp32_1 = Wait_Level(1, temp32_2+15, 3) ;              // λ0ʱ,  -90 ʱ
  if(temp32_1 >>24){             //  LED_LIGHT_0() ;      // ָʾһ  
       
                     //  B ෴             // ֻһѹ, ޷жת   
    if( 0  /* Vb >Va */) Reverse = 7 ;                    // ˿B෴ƸA, ACBת
    
    if(Wait_Level(0, temp32_2-15, 3)>>24){                // 
      temp32 = Wait_Level(1, temp32_2+15, 3) ;            // ڶȷϴٵ,Ӧ      
      if(temp32 >>24){               //      LED_DARK_1();  
        temp32 = (temp32 - temp32_1)&0xFFFFFF ;           // ⵽ֵ us
        temp32 = 2048000000ul/temp32 ;                    //65536/(temp32/1000000)¾䲹5
        temp32_1 = 0;        
        if(temp32  <  0x0003FFFF ) temp32_1 = 8;          //  8+5 λ
        else if(temp32 <0x007FFFFF) temp32_1 = 3;         //  3+5 λ
        temp32 =((temp32 <<(temp32_1+5))/PWM_Frequency) <<(16-temp32_1);  // Ʒּڷ  
        if(Reverse) temp32 = -temp32 ;                                    // ACB ת,ظֵ
        
//        if(Rotation_Direction) temp32 = -temp32 ;       // ָACBת,ֻA෴ȥ˾
      }
      else temp32 = 0 ;                                   //  ûת,0
    }  
  }   
  return temp32 ;                                         // ֵ0ǲ⵽ֵ, ֵǷת
}

//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   ʣַ
uint32_t Tx0FillFiFo(char*pStr, uint32_t Cnt)
{
  while(Cnt){                                                      
    if(UART0->FIFOSTS & UART_FIFOSTS_TXFULL_Msk ) break ;  // FiFo      
    UART0->DAT = *pStr++ ;      --Cnt ;                                                                           
  }
  return  Cnt ;                                          
}
////convert a integer into a string for printing /////////////////////////////////////////
//input : Number, 32bit integer
//       *pStr,  Ÿλַĵַ, ÿһλ, ַ1    
//return: Sum of character converted.
const uint8_t Asc[16]="0123456789ABCDEF" ;
uint32_t BinToDec_Str(uint32_t Number, char*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{
    temp32u = Number ; 
    Number /= 10 ; 
    *pStr-- = Asc[temp32u - Number*10];                    // =0ʱ,һ0
    ++Cnt ;
  }while(Number);
  return Cnt ;
}

uint32_t BinToHex_Str(uint32_t Number, char*pStr)
{
  uint32_t temp32u, Cnt = 0 ;

  do{
    temp32u = Number ; 
    Number >>= 4 ; 
    *pStr-- = Asc[temp32u - (Number <<4)] ;               // =0ʱ,һ0
    ++Cnt ;
  }while(Number);
  return Cnt ;
}
